#!/usr/bin/perl

use strict;

my @list=('epl2011-initial','epl2011-table1','epl2011-69',
          'np2009-1','np2009-2','deoxyinosine_pb','predict-1','predict-2',
          'predict-salt50','open-1','open-cy3','rna-bulges-predict','verify-tna');
          
my $system_id=`lsb-release -d`;

my $bin='tfreg';
my $scriptdir='/usr/share/TfReg/examples';
my $data='/usr/share/TfReg/data';
my $exampledir='/usr/share/TfReg/examples';
my $verifydir='/usr/share/TfReg/examples/verify';
my $rundir="/tmp/tfreg-verify/$ENV{'LOGNAME'}";

$bin=$ENV{'TFREGBIN'} if (exists $ENV{'TFREGBIN'});

$verifydir=$ENV{'VERIFYDIR'} if (exists $ENV{'VERIFYDIR'});

$scriptdir=$ENV{'SCRIPTDIR'} if (exists $ENV{'SCRIPTDIR'});

$data=$ENV{'DATADIR'} if (exists $ENV{'DATADIR'});

$rundir=$ENV{'RUNDIR'} if (exists $ENV{'RUNDIR'});

@list=($ENV{'LIST'}) if (exists $ENV{'LIST'});

print "bin=$bin\n";
print "verifydir=$verifydir\n";
print "scriptdir=$scriptdir\n";
print "datadir=$data\n";
print "rundir=$rundir\n";
print "list=",join(',',@list),"\n";

if ($system_id =~ /Ubuntu/)
  {
  my $scriptdir='/usr/share/tfreg/examples';
  my $data='/usr/share/tfreg/data';
  my $exampledir='/usr/share/tfreg/examples';
  my $verifydir='/usr/share/tfreg/examples/verify'; 
  }

if ($ARGV[0] eq 'local')
  {
  $bin='../tfreg';
  $scriptdir='.';
  $data='../data';
  $exampledir='.';
  $verifydir='verify';
  $rundir=".";
  }
else
  {
  system("mkdir -p $rundir");
  }
  
  
my @verification_list;
foreach my $script (@list)
  {
  system("export BIN=$bin;export PREFIX=$data;cd $rundir;$scriptdir/$script.sh");
  my @verify_files=glob("$verifydir/$script*");
  if (-d "$verifydir/$script")
    {
    push(@verify_files,glob("$verifydir/$script/*"));
    }
  foreach my $result (@verify_files)
    {
    my $local_result=$result;
    $local_result =~ s/$verifydir\///g;
    push(@verification_list,"diff -s $rundir/$local_result $result");
    }
  }
 
print "\nNow comparing files, all results should be identical\n";
my $ok=0;
my $filen=0;
foreach my $verification (@verification_list)
  {
  $filen++;
  my $ver=`$verification`;
  if ($ver =~ / are identical/)
    {
    $ok++;
    }
  else
    {
    print "\n$verification\n";
    system($verification);
    }
  }
  
print "\n***** $ok of $filen files OK\n"; 
